function prefchanged(select)
{	
	var index = select.selectedIndex;
	
	switch(index) {
		case 0:
			switchDiv('about');
			break;

		case 1:
			switchDiv('recipient');
			break;
			
		case 2:
			switchDiv('groups');
			break;
			
		case 3:
			switchDiv('account');
			break;
			
		case 4:
			switchDiv('callerID');
			switchReplyPane(getReplyValue());
			break;

		case 5:
			switchDiv('country');
			break;

		case 6:
			switchDiv('signature');
			break;

		case 7:
			switchDiv('reports');
			break;

		case 8:
			switchDiv('skins');
			break;
/*
		case 9:
			setPopup2();
			switchDiv('emobile');
			break;
*/
		case 9:
			switchDiv('update');
			showUpdate();
			break;
			
		case 10:
			switchDiv('buy');
			break;
	}
	
	updateMobileNumber();
}

function switchDiv(div_id)
{
  var style_sheet = getStyleObject(div_id);
  if (style_sheet)
  {
    hideAll();
    changeObjectVisibility(div_id,"visible");
  }
}

//  hides a bunch of divs

function hideAll()
{
   changeObjectVisibility("about","hidden");
   changeObjectVisibility("recipient","hidden");
   changeObjectVisibility("groups","hidden");
   changeObjectVisibility("account","hidden");
   changeObjectVisibility("callerID","hidden");
   changeObjectVisibility("country","hidden");
   changeObjectVisibility("signature","hidden");
   changeObjectVisibility("reports","hidden");
   changeObjectVisibility("skins","hidden");
   changeObjectVisibility("update","hidden");
   changeObjectVisibility("buy","hidden");
   //changeObjectVisibility("emobile","hidden");
   
   changeObjectVisibility("label21","hidden");
   changeObjectVisibility("download","hidden");
   
   changeObjectVisibility("replytomobile","hidden");
   changeObjectVisibility("replytoemail","hidden");
   changeObjectVisibility("noreply","hidden");
}

// function getStyleObject(string) -> returns style object
//  given a string containing the id of an object
//  the function returns the stylesheet of that object
//  or false if it can't find a stylesheet.  Handles
//  cross-browser compatibility issues.
//
function getStyleObject(objectId) {
  if(document.getElementById && document.getElementById(objectId)) {
        return document.getElementById(objectId).style;
   } else {
        return false;
   }
}

function changeObjectVisibility(objectId, newVisibility) {
    // first get a reference to the cross-browser style object 
    // and make sure the object exists
    var styleObject = getStyleObject(objectId);
    if(styleObject) {
        styleObject.visibility = newVisibility;
        return true;
    } else {
        // we couldn't find the object, so we can't change its visibility
        return false;
    }
}

function showVersion()
{
	document.getElementById('label22').innerText = getLocalizedString('Send SMS Version') + productVersion;
}

function setBalance(value)
{
	if (value == null) {
		document.getElementById('label36').innerText = getLocalizedString('SMS Balance') + getLocalizedString('na');
	} else {
		document.getElementById('label36').innerText = getLocalizedString('SMS Balance') + value;
	}
}

function setupPreferences()
{
	var userColor;
			
	if (window.widget)
	{
		// first set some default preferences
		
		// default is 'reply to:'
		var reply = document.getElementById('signaturetxt');
		if (reply != null)
			reply.value = getLocalizedString('Reply');
		
		// default is 'No Reply'
		setReplyValue(2);
		
		// default SMS balance is 'n/a'
		setBalance(null);
		
		// default is 'Undefined Caller ID'
		var element = document.getElementById("noalphanumericID");
		element.checked = 1;

		// read the user's preferences
		var data = widget.preferenceForKey(createkey("mail"));
		if (data != null)
		{
			var emailAddress = data;
			alert('Send SMS is reading preferences');
			
			// get email address
			var element = document.getElementById("mail");
			element.value = data;
		
			// get PIN code
			data = widget.preferenceForKey(createkey("pin"));
			if (data != null && data.length > 0)
			{
				var element = document.getElementById("pin");
				element.value = data;
								
			} else {
			
				// read PIN from Keychain
				readPIN();
			}
			
			// has account
			data = widget.preferenceForKey(createkey("has"));
			if (data != null)
			{				
				hasAccount = data;
			}
			
			/*
			// show SMS balance
			data = widget.preferenceForKey(createkey("balance"));
			if (data != null)
			{				
				setBalance(data);
				smsbalance = data;
			}
			*/
			
			// get caller ID
			data = widget.preferenceForKey(createkey("caller"));
			if (data != null)
			{				
				var element = document.getElementById("caller");
				element.value = data;
			}
			
			// get report email address
			data = widget.preferenceForKey(createkey("reportemailaddress"));
			if (data != null)
			{				
				var element = document.getElementById("report");
				element.value = data;
			} else {
				var element = document.getElementById("report");
				element.value = emailAddress;
			}

			// get reply email address
			data = widget.preferenceForKey(createkey("replyemailaddress"));
			if (data != null)
			{				
				var element = document.getElementById("replyemailaddress");
				element.value = data;
			}

			// get alphanumeric Caller ID
			data = widget.preferenceForKey(createkey("alphanumericID"));
			if (data != null)
			{				
				var element = document.getElementById("alphanumericID");
				element.value = data;				
			}

			// enable alphanumeric Caller ID
			data = widget.preferenceForKey(createkey("usealphanumericID"));
			if (data != null)
			{				
				var element = document.getElementById("usealphanumericID");
				element.checked = data;
				
				if (data == 1) {
					element = document.getElementById("noalphanumericID");
					element.checked = 0;
				}
			}
			
			var data0 = 0;
			var data1 = 0;
			
			// reply to mobile preference
			data0 = widget.preferenceForKey(createkey("addcaller"));
			if (data0 != null)
			{				
				if (data0 == 1) {
					setReplyValue(0);// reply to mobile
				}
			}

			// reply to email preference
			data1 = widget.preferenceForKey(createkey("replybyemail"));
			if (data1 != null)
			{				
				if (data1 == 1) {
					setReplyValue(1);// reply to email
				}
			}

			// no reply preference
			if (data0 == 0 && data1 == 0) {
				setReplyValue(2);// no reply
			}
			
			// enable delivery reports
			data = widget.preferenceForKey(createkey("delivery"));
			if (data != null)
			{				
				var element = document.getElementById("delivery");
				element.checked = data;
			}

			// enable copy sms
			data = widget.preferenceForKey(createkey("copysms"));
			if (data != null)
			{				
				var element = document.getElementById("copysms");
				element.checked = data;
			}

			// get strip zero
			data = widget.preferenceForKey(createkey("stripzero"));
			if (data != null)
			{				
				var element = document.getElementById("stripzero");
				element.checked = data;
			}

			// enable add country code
			data = widget.preferenceForKey(createkey("addcountrycode"));
			if (data != null)
			{				
				var element = document.getElementById("addcountrycode");
				element.checked = data;
			}

			// get country code
			data = widget.preferenceForKey(createkey("countrycode"));
			if (data != null)
			{				
				var element = document.getElementById("countrycode");
				element.value = data;
			}

			// enable signature
			data = widget.preferenceForKey(createkey("addsignature"));
			if (data != null)
			{				
				var element = document.getElementById("addsignature");
				element.checked = data;
			}
			
			// get signature
			data = widget.preferenceForKey(createkey("signaturetxt"));
			if (data != null)
			{				
				var element = document.getElementById("signaturetxt");
				element.value = data;
			}
			
		} else {
			// read SMS Mac Address Book plug-in preferences
			readSMSMacPrefs();
		}

		// read preferred color of this instance
		var key = widget.identifier + "-" + "color";
		userColor = widget.preferenceForKey(key);
		if (userColor == null) {
			userColor = widget.preferenceForKey("color");
			if (userColor == null) {
				userColor = 'red';
			}
		}
	}
	
	// localize
	var prefs = document.getElementById('preferences');
	if (prefs != null)
		localizePreferences(prefs);
		
	// localize
	prefs = document.getElementById('replyprefs');
	if (prefs != null)
		localizeReplyPreferences(prefs);

	/*
	// localize
	prefs = document.getElementById('gates');
	if (prefs != null)
		localizeSelectNetwork(prefs);
	*/
	
	// select the right skip color in the popup menu
	if (userColor != null) {
		var cpopup = document.getElementById('cpopup');
		
		if (cpopup != null) {
			var colorArray = new Array;
			colorArray["grey"] = 0;
			colorArray["white"] = 1;
			colorArray["red"] = 2;
			colorArray["green"] = 3;
			colorArray["blue"] = 4;
			colorArray["orange"] = 5;
			
			var cindex = colorArray[userColor];
			document.getElementById("cpopup").options[cindex].selected=true;
			
			localizeColors(cpopup);
			
			updatefontcolor(userColor);
			
			updatebkfontcolor(userColor);
		}
	}
	
	document.getElementById('label1').innerText = getLocalizedString('Account ID:');
	document.getElementById('label2').innerText = getLocalizedString('PIN code:');
	document.getElementById('label3').innerText = getLocalizedString('To:');
	document.getElementById('label4').innerText = getLocalizedString('Skins:');
	document.getElementById('label5').innerText = getLocalizedString('Add Caller ID');
	document.getElementById('label6').innerText = getLocalizedString('Caller ID:');
	document.getElementById('label7').innerText = getLocalizedString('Add Country Code');
	document.getElementById('label8').innerText = getLocalizedString('Country Code:');
	document.getElementById('label9').innerText = getLocalizedString('Strip Zero');
	document.getElementById('label10').innerText = getLocalizedString('Add Signature');
	document.getElementById('label11').innerText = getLocalizedString('Signature:');
	document.getElementById('label12').innerText = getLocalizedString('Email delivery reports');
	document.getElementById('label14').innerText = getLocalizedString('SMS Mac Info');
	document.getElementById('label15').innerText = getLocalizedString('Email Address:');
	document.getElementById('label16').innerText = getLocalizedString('Alphanumeric Caller ID:');
	document.getElementById('label17').innerText = getLocalizedString('International Format');
	document.getElementById('label18').innerText = getLocalizedString('Email Costs');
	document.getElementById('label19').innerText = getLocalizedString('Alphanumeric Info');
	document.getElementById('label20').innerText = getLocalizedString('Undefined Caller ID');
	document.getElementById('label21').innerText = getLocalizedString('Checking');
	document.getElementById('label22').innerText = getLocalizedString('Send SMS Version');
	document.getElementById('label23').innerText = getLocalizedString('Copyright');
	document.getElementById('label24').innerText = getLocalizedString('Country Info');
	document.getElementById('label25').innerText = getLocalizedString('Signature Info');
	//document.getElementById('label26').innerText = getLocalizedString('Delivery Info');
	document.getElementById('label27').innerText = getLocalizedString('Type Ahead');
	document.getElementById('label28').innerText = getLocalizedString('Skins Info');
	document.getElementById('label29').innerText = getLocalizedString('About SMS Mac');
	//document.getElementById('label30').innerText = getLocalizedString('To:');
	//document.getElementById('label31').innerText = getLocalizedString('eMobile Address:');
	document.getElementById('label32').innerText = getLocalizedString('To group:');
	document.getElementById('label33').innerText = getLocalizedString('Number of mobiles:');
	document.getElementById('label34').innerText = getLocalizedString('Copy SMS');
	document.getElementById('label35').innerText = getLocalizedString('Send reports');
	//document.getElementById('label37').innerText = getLocalizedString('Balance Comment');
	
	// show widget version
	showVersion();
	
	// tooltips
	document.getElementById('editdiv').title = getLocalizedString('Enter Text Here');
	document.getElementById('total').title = getLocalizedString('Number Of Characters');
	document.getElementById('unicode').title = getLocalizedString('Unicode Indicator');
	document.getElementById('icon').title = getLocalizedString('Send SMS');
	document.getElementById('eraser').title = getLocalizedString('Erase Screen');
	document.getElementById('flip').title = getLocalizedString('Edit Preferences');

	var homeButton = document.getElementById('home');
	createGenericButton(homeButton, 'www.smsmac.com', goHome);	 	

	var doneButton = document.getElementById('done');
	createGenericButton(doneButton, getLocalizedString('Done'), doneMouseUp);	 	

	var helpButton = document.getElementById('help');
	createGenericButton(helpButton, getLocalizedString('Help'), doHelp);	 	
	
	var checkUpdateButton = document.getElementById('checkupdate');
	createGenericButton(checkUpdateButton, getLocalizedString('Check'), doCheckForUpdates, 150);	 	
	
	var checkBalanceButton = document.getElementById('checkbalance');
	createGenericButton(checkBalanceButton, getLocalizedString('Query'), doQueryBalance, 150);	 	

	var downloadButton = document.getElementById('download');
	createGenericButton(downloadButton, getLocalizedString('Download'), doDownloadUpdate, 150);	 	

	//var addABButton = document.getElementById('addab');
	//createGenericButton(addABButton, getLocalizedString('Add to AB'), doAddEMobile, 150);	 	

	var reloadButton = document.getElementById('reloadc');
	createGenericButton(reloadButton, getLocalizedString('Reload Contacts'), doReloadContacts, 150);	 	

	var reloadButton = document.getElementById('resendpin');
	createGenericButton(reloadButton, getLocalizedString('Resend PIN'), doResendPIN, 80);	 	

	if (hasAccount) {
		var orderButton = document.getElementById('order');
		createGenericButton(orderButton, getLocalizedString('Buy SMS!'), doOrder, 150);	 	
	} else {
		var orderButton = document.getElementById('order');
		createGenericButton(orderButton, getLocalizedString('Sign On!'), doOrder, 150);	 	
	}
	
	updateHasAccountStatus(hasAccount);	
}

function colorchanged(elem)
{
	var image = 'images/front.png';
	
	// find color of skin
	userColor = elem.options[elem.selectedIndex].value;	
	switch(userColor) {
		case 'red':
			image = 'images/red.png';
			break;
			
		case 'green':
			image = 'images/green.png';
			break;
			
		case 'blue':
			image = 'images/blue.png';
			break;
			
		case 'orange':
			image = 'images/orange.png';
			break;
			
		case 'white':
			image = 'images/white.png';
			break;
		
		default:
			image = 'images/front.png';
			break;
			
	}

	// change color of skin
	var note = document.getElementById('note');
	note.src = image;
	
	updatefontcolor(userColor);
	
	// change the backside
	switch(userColor) {
		case 'red':
			image = 'images/red_back.png';
			break;
			
		case 'green':
			image = 'images/green_back.png';
			break;
			
		case 'blue':
			image = 'images/blue_back.png';
			break;
			
		case 'orange':
			image = 'images/orange_back.png';
			break;
			
		case 'white':
			image = 'images/white_back.png';
			break;
		
		default:
			image = 'images/back.png';
			break;
			
	}

	// change color of skin
	var backside = document.getElementById("back");
	backside.src = image;
	
	updatebkfontcolor(userColor);
}

function updatefontcolor(color)
{
	var elem = document.getElementById("head");
	
	switch(color) {
		case 'red':
		case 'blue':
		case 'green':
		case 'orange':
			elem.style.color='black';
			break;
			
		default:
			elem.style.color='white';
			break;
	}
	
	elem = document.getElementById("total");
	
	switch(color) {
		case 'red':
		case 'blue':
		case 'green':
		case 'orange':
			elem.style.color='#666666';
			break;
			
		case 'white':
			elem.style.color='#FFFFFF';
			break;
			
		default:
			elem.style.color= '#999999';
			break;
	}
	
	elem = document.getElementById("unicode");
	
	switch(color) {
		case 'red':
		case 'blue':
		case 'green':
		case 'orange':
			elem.style.color='#666666';
			break;
			
		case 'white':
			elem.style.color='#FFFFFF';
			break;
			
		default:
			elem.style.color= '#999999';
			break;
	}
	
}

function updatebkfontcolor(color)
{
	for(var i = 1;i<=36;i++) {
	
		var id = "label" + i;
		
		var elem = document.getElementById(id);
		if (elem == null) continue;
		
		switch(color) {
			case 'white':
				elem.style.color='black';
				break;
				
			default:
				elem.style.color='white';
				break;
		}
	}
	
	return;	
}

function localizeColors(elem)
{
	elem.options[0].text = getLocalizedString('Grey');
	elem.options[1].text = getLocalizedString('White');
	elem.options[2].text = getLocalizedString('Red');
	elem.options[3].text = getLocalizedString('Green');
	elem.options[4].text = getLocalizedString('Blue');
	elem.options[5].text = getLocalizedString('Orange');
}

function localizePreferences(elem)
{
	elem.options[0].text = getLocalizedString('About');
	elem.options[1].text = getLocalizedString('Recipient');
	elem.options[2].text = getLocalizedString('Group');
	elem.options[3].text = getLocalizedString('Account');
	elem.options[4].text = getLocalizedString('Caller ID');
	elem.options[5].text = getLocalizedString('Country Code');
	elem.options[6].text = getLocalizedString('Signature');
	elem.options[7].text = getLocalizedString('Delivery');
	elem.options[8].text = getLocalizedString('Skins');
	//elem.options[9].text = getLocalizedString('eMobile');
	elem.options[9].text = getLocalizedString('Update');
	elem.options[10].text = getLocalizedString('Balance');
	
	if (hasAccount)
		elem.options[10].text = getLocalizedString('Balance');
	else
		elem.options[10].text = getLocalizedString('Sign On!');
}

function localizeReplyPreferences(elem)
{
	elem.options[0].text = getLocalizedString('Reply to Mobile');
	elem.options[1].text = getLocalizedString('Reply to Email');
	elem.options[2].text = getLocalizedString('No Reply');
}
/*
function localizeSelectNetwork(elem)
{
	elem.options[0].text = getLocalizedString('Select Network');
}
*/
function updateHasAccountStatus(hasAccountFlag) {
	var elem = document.getElementById('preferences');
	if (elem != null) {
	
		if (hasAccountFlag) 
			elem.options[10].text = getLocalizedString('Balance');
		else
			elem.options[10].text = getLocalizedString('Sign On!');

	}
	
	if (hasAccountFlag) 
		document.getElementById('label14').innerText = getLocalizedString('SMS Info');
	else
		document.getElementById('label14').innerText = getLocalizedString('SMS Mac Info');
		
	// uses built-in knowledge of the genericButton.js code
	var div = document.getElementById('order');
	if (div != null) {
		if (hasAccountFlag) 
			div.childNodes[1].innerHTML = getLocalizedString('Buy SMS!');
		else
			div.childNodes[1].innerHTML = getLocalizedString('Sign On!');
	}
}